/*
 * list.h
 *
 * Copyright 2006, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * ꥹѥإåե
 */


#ifndef list_h
#define list_h


#include <kern/debug.h>


#ifndef ASM_FILE


/*
 *աեץ饤١ѡι¤Τ¾ǤϻȤʤ
 */
typedef struct list{
	struct list *next;
	struct list *prev;
} LIST;

/*
 * ѥ֥åѥꥹ
 *աɬľܥСˤ뤳
 */
typedef struct{
	char dummy[sizeof(LIST)];
} OBJ_LIST;


/*****************************************************************************************
* 
******************************************************************************************/

extern void *getNextList(const size_t offset, const OBJ_LIST *i_src);
extern void *getPrevList(const size_t offset, const OBJ_LIST *i_src);
extern void *getHeadObj(const size_t offset, const OBJ_LIST *head);

/*****************************************************************************************
* ñꥹ
******************************************************************************************/

extern void initList(OBJ_LIST *m_src);
extern void addHeadList(OBJ_LIST **m_head, OBJ_LIST *m_src);
extern void addList(OBJ_LIST *m_dst, OBJ_LIST *m_src);

/*****************************************************************************************
* ξ۴ĥꥹ
******************************************************************************************/

extern void initCirculList(OBJ_LIST *m_src);
extern void addNextList(OBJ_LIST *m_dst, OBJ_LIST *m_src);
extern void addPrevList(OBJ_LIST *m_dst, OBJ_LIST *m_src);
extern void removeList(OBJ_LIST *m_src);
extern void addHeadNextList(OBJ_LIST **m_head, OBJ_LIST *m_src);
extern void addHeadPrevList(OBJ_LIST **m_head, OBJ_LIST *m_src);
extern void removeFromHeadList(OBJ_LIST **m_head, OBJ_LIST *m_src);


#endif


#endif
